C  CONTROL BLOCK FOR THE DEVICE-DEPENDENT AREA EXTENSION FOR
C  GENERATING DISPLAY FILES FOR THE TEKTRONIX 4510 COLOR GRAPHICS
C  RASTERIZER.
      SAVE          /UGWZ00/
C  NUMBER OF CHARACTERS IN THE OUTPUT BUFFER.
      INTEGER       DDXZ1
      PARAMETER     (DDXZ1=152)
C  X AND Y LIMITS OF COORDINATES IN THE TERMINAL SPACE.
      INTEGER       DDXZ2,DDXZ3
      PARAMETER     (DDXZ2=4095,DDXZ3=3132)
C  CONTROL BLOCK LENGTH.
      INTEGER       DDXZZ
      PARAMETER     (DDXZZ=61)
C  THE DECLARATION OF THE COMMON BLOCK.
      COMMON        /UGWZ00/
     X              DDXID,
     X              DDXBF,DDXBM,DDXBN,
     X              DDXLR,DDXNO,DDXIL,
     X              DDXCC,DDXCL,DDXCW,DDXCD,DDXCA,DDXCZ,DDXCP,
     X              DDXXD,DDXYD,
     X              DDXFF,DDXOP,DDXX1,DDXMM,
     X              DDXPV,DDXDC,
     X              DDXIO
C  DEVICE-DEPENDENT AREA EXTENSION IDENTIFICATION.
      CHARACTER*8   DDXID
C  THE INPUT/OUTPUT BUFFER.
      CHARACTER*(DDXZ1) DDXBF
C  MAXIMUM NUMBER OF CHARACTERS THAT WILL FIT INTO THE INPUT/OUTPUT
C  BUFFER.
      INTEGER       DDXBM
C  NUMBER OF CHARACTERS CURRENTLY IN THE INPUT/OUTPUT BUFFER.
      INTEGER       DDXBN
C  LOW RESOLUTION FLAG:
C    0 MEANS USE HIGH RESOLUTION, AND
C    1 MEANS USE LOW RESOLUTION.
      INTEGER       DDXLR
C  NO OPTIMIZATION FLAG:
C    0 MEANS DO THE OPTIMIZATION, AND
C    1 MEANS DO NOT DO THE OPTIMIZATION.
      INTEGER       DDXNO
C  GENERATE INTENSITY LEVEL WITH LINE WIDTH FLAG:
C    0 MEANS DO NOT GENERATE LINE STRUCTURE, AND
C    1 MEANS GENERATE LINE STRUCTURE.
      INTEGER       DDXIL
C  CURRENT LINE AND MARKER COLOR INDEX.
      INTEGER       DDXCC
C  CURRENT LINE TYPE.
      INTEGER       DDXCL
C  CURRENT LINE WIDTH.
      INTEGER       DDXCW
C  CURRENT TEXT COLOR INDEX.
      INTEGER       DDXCD
C  CURRENT TEXT ANGLE.
      INTEGER       DDXCA
C  CURRENT TEXT SIZE.
      INTEGER       DDXCZ
C  CURRENT FILL PATTERN.
      INTEGER       DDXCP
C  CHARACTER SPACING FOR CURRENT TEXT SIZE.
      INTEGER       DDXXD,DDXYD
C  FIRST END POINT FLAG:
C    .TRUE.  MEANS THIS IS THE FIRST OF A GROUP OF END POINTS, AND
C    .FALSE. MEANS IT IS NOT.
      LOGICAL       DDXFF
C  LAST POSITIONING ORDER AND PADDING.
      CHARACTER*5   DDXOP
      CHARACTER*3   DDXX1
C  MARKER MODE FLAG:
C    0 MEANS NOT IN MARKER MODE, AND
C    1 MEANS IN MARKER MODE.
      INTEGER       DDXMM
C  PICTURE AVAILABLE FLAG:
C    0 MEANS NO PREVIOUS PICTURE IS AVAILABLE, AND
C    1 MEANS A PICTURE HAS BEEN PREVIOUSLY PRODUCED.
      INTEGER       DDXPV
C  DEFERRED CLEAR FLAG:
C    0 MEANS THE START OF A NEW PICTURE HAS NOT BEEN DEFERRED, AND
C    1 MEANS THE START OF A NEW PICTURE HAS BEEN DEFERRED.
      INTEGER       DDXDC
C  INPUT/OUTPUT IDENTIFICATION VALUE.
      INTEGER       DDXIO
C  THE FOLLOWING ARRAY OVERLAYS THE ENTIRE DDA EXTENSION.
      INTEGER       DDXRY(DDXZZ)
      EQUIVALENCE   (DDXRY(1),DDXID)
